/*
 * Author: Richard Lord
 * Copyright (c) Richard Lord 2010
 * http://www.richardlord.net
 * 
 * Licence Agreement
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

package net.richardlord.smartcomponents.common.log
{
	import mx.logging.ILogger;
	import mx.managers.ISystemManager;
	
	import net.expantra.smartypants.extra.NoSmartyPantsLogging;
	import net.expantra.smartypants.impl.sp_internal;
	import net.expantra.smartypants.utils.SPLoggingUtil;
	
	[Mixin]
	public class SmartyPantsNoLog
	{
		use namespace sp_internal;
		
		public static function init( system : ISystemManager ) : void
		{
			SPLoggingUtil.getDefaultLoggerWorkFunction = getSPNoLogger;
		}
		
		private static function getSPNoLogger( name : String ) : ILogger
		{
			return new NoSmartyPantsLogging( name );
		}
	}
}