/*
 * Author: Richard Lord
 * Copyright (c) Richard Lord 2010
 * http://www.richardlord.net
 * 
 * Licence Agreement
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

package net.richardlord.smartcomponents.twitter.canvases
{
	import net.expantra.smartypants.Injector;
	import net.richardlord.smartcomponents.common.containers.ToggleVisibleCanvas;
	import net.richardlord.smartcomponents.twitter.signals.SignalBus;
	
	public class TweetCanvas extends ToggleVisibleCanvas
	{
		[Inspectable( environment="none" )]
		[Inject]
		public var signalBus : SignalBus;
		
		[PostConstruct]
		public function setUpListeners( injector : Injector ) : void
		{
			signalBus.showCreateTweet.add( showMe );
			signalBus.hideCreateTweet.add( hideMe );
			signalBus.toggleCreateTweet.add( toggleMe );
		}
	}
}