/*
 * Author: Richard Lord
 * Copyright (c) Richard Lord 2010
 * http://www.richardlord.net
 * 
 * Licence Agreement
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

package net.richardlord.smartcomponents.twitter.data
{
	import flash.events.Event;
	import flash.events.EventDispatcher;
	
	public class Tweet extends EventDispatcher
	{
		private var _id : Number;
		private var _created : Date;
		private var _link : String;
		private var _text : String;
		private var _html : String;
		private var _image : String;
		private var _source : String;
		private var _authorName : String;
		private var _authorUri : String;
		
		[Bindable( event="idChanged" )]
		public function get id() : Number
		{
			return _id;
		}
		
		public function set id( value : Number ) : void
		{
			if ( value != _id )
			{
				_id = value;
				dispatchEvent( new Event( "idChanged" ) );
			}
		}
		
		[Bindable( event="createdChanged" )]
		public function get created() : Date
		{
			return _created;
		}
		
		public function set created( value : Date ) : void
		{
			if ( value != _created )
			{
				_created = value;
				dispatchEvent( new Event( "createdChanged" ) );
			}
		}
		
		[Bindable( event="linkChanged" )]
		public function get link() : String
		{
			return _link;
		}
		
		public function set link( value : String ) : void
		{
			if ( value != _link )
			{
				_link = value;
				dispatchEvent( new Event( "linkChanged" ) );
			}
		}
		
		[Bindable( event="textChanged" )]
		public function get text() : String
		{
			return _text;
		}
		
		public function set text( value : String ) : void
		{
			if ( value != _text )
			{
				_text = value;
				dispatchEvent( new Event( "textChanged" ) );
			}
		}
		
		[Bindable( event="htmlChanged" )]
		public function get html() : String
		{
			return _html;
		}
		
		public function set html( value : String ) : void
		{
			if ( value != _html )
			{
				_html = value;
				dispatchEvent( new Event( "htmlChanged" ) );
			}
		}
		
		[Bindable( event="imageChanged" )]
		public function get image() : String
		{
			return _image;
		}
		
		public function set image( value : String ) : void
		{
			if ( value != _image )
			{
				_image = value;
				dispatchEvent( new Event( "imageChanged" ) );
			}
		}
		
		[Bindable( event="sourceChanged" )]
		public function get source() : String
		{
			return _source;
		}
		
		public function set source( value : String ) : void
		{
			if ( value != _source )
			{
				_source = value;
				dispatchEvent( new Event( "sourceChanged" ) );
			}
		}
		
		[Bindable( event="authorNameChanged" )]
		public function get authorName() : String
		{
			return _authorName;
		}
		
		public function set authorName( value : String ) : void
		{
			if ( value != _authorName )
			{
				_authorName = value;
				dispatchEvent( new Event( "authorNameChanged" ) );
			}
		}
		
		[Bindable( event="authorUriChanged" )]
		public function get authorUri() : String
		{
			return _authorUri;
		}
		
		public function set authorUri( value : String ) : void
		{
			if ( value != _authorUri )
			{
				_authorUri = value;
				dispatchEvent( new Event( "authorUriChanged" ) );
			}
		}
		
		[Bindable( event="publishedChanged" )]
		public function get publishedRelative() : int
		{
			var now : Date = new Date();
			return ( now.time - _created.time ) * 0.001;
		}
		
		override public function toString() : String
		{
			return _text;
		}
	}
}
