/*
 * Author: Richard Lord
 * Copyright (c) Richard Lord 2010
 * http://www.richardlord.net
 * 
 * Licence Agreement
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

package net.richardlord.smartcomponents.twitter.formatters
{
	import mx.formatters.Formatter;
	
	public class PeriodFormatter extends Formatter
	{
		override public function format( value : Object ) : String
		{
			var period : Number = Math.round( Number( value ) );
			
			if ( period <= 1 )
				return "1 second ago";
			
			if ( period < 60 )
				return period + " seconds ago";
			
			period = Math.round( period / 60 );
			
			if ( period <= 1 )
				return "1 minute ago";
			
			if ( period < 60 )
				return period + " minutes ago";
			
			period = Math.round( period / 60 );
			
			if ( period <= 1 )
				return "1 hour ago";
			
			if ( period < 60 )
				return period + " hours ago";
			
			period = Math.round( period / 24 );
			
			if ( period <= 1 )
				return "1 day ago";
			
			return period + " days ago";
		}
	}
}